// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.helper', 'directives.searchform', 'directives.bar'])


.run(function ($ionicPlatform) {
    $ionicPlatform.ready(function () {

        if (typeof analytics !== 'undefined') {
            analytics.startTrackerWithId('UA-24367661-24');
        }

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
    })


  .state('app.index', {
      url: '/index/:day/:page',
      views: {
          'appContent': {
              templateUrl: 'templates/pages/index.html',
              controller: 'index',
          },
          'sideContent': {
              templateUrl: 'templates/menus/index.html',
          }
      }
  })



  .state('app.search', {
      url: '/search/:day/:page/:query',
      views: {
          'appContent': {
              templateUrl: 'templates/pages/search.html',
              controller: 'search',
          },
          'sideContent': {
              templateUrl: 'templates/menus/search.html',
          }
      }
  })




  .state('app.show', {
      url: '/show/:day/:id',
      views: {
          'appContent': {
              templateUrl: 'templates/pages/show.html',
              controller: 'show',
          },
          'sideContent': {
              templateUrl: 'templates/menus/show.html',
          }
      }
  })



  .state('app.starred', {
      url: '/starred/:day',
      cache: false,
      views: {
          'appContent': {
              templateUrl: 'templates/pages/starred.html',
              controller: 'starred'
          },
          'sideContent': {
              templateUrl: 'templates/menus/starred.html',
          }
      }
  })



    // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/index/' + new Date().getDay() + '/1');
});
