angular.module('starter.controllers', ['starter.services', 'ngGeolocation', 'ngStorage'])


.controller('AppCtrl', function ($scope, $ionicModal, $timeout) {

})



.controller('index', function ($scope, $stateParams, $geolocation, $cordovaLaunchNavigator, Index, Distance, Navigate_maps, $state) {
    $scope.loader = 'show';
    if (typeof analytics !== 'undefined') { analytics.trackView('index/'+$stateParams.day+'/'+$stateParams.page) }
    //call geolocation service here
    ionic.Platform.ready(function(){
    $geolocation.getCurrentPosition({
        timeout: 60000
    }).then(function (position) {
        $scope.myPosition = position;
        Index.get({'lat': position.coords.latitude, 'lng': position.coords.longitude, 'selected_day': $stateParams.day, 'page': $stateParams.page}).$promise.then(function (response) {
            $scope.loader = "hide";
            $scope.Index = response;
        })
    })

        //refresh the page
        $scope.doRefresh = function () {
            if (typeof analytics !== 'undefined') { analytics.trackView('index/' + $stateParams.day + '/' + $stateParams.page) }
            $geolocation.getCurrentPosition({
                timeout: 60000
            }).then(function (position) {
                $scope.myPosition = position;
                Index.get({'lat': position.coords.latitude, 'lng': position.coords.longitude, 'selected_day': $stateParams.day, 'page': $stateParams.page}).$promise.then(function (response) {
                    $scope.Index = response;
                })
            })
         .finally(function() {
           // Stop the ion-refresher from spinning
           $scope.$broadcast('scroll.refreshComplete');
         });
      };

    });

    //map-pin click function
    $scope.navigate = function (lat, lng) {
        dest = lat + ',' + lng
        start = null;
        $cordovaLaunchNavigator.navigate(dest, {
            start: start,
            enableDebug: false
        }).then(function () {
            alert("Navigator launched");
        }, function (err) {
            alert(err);
        });
    }

    //distance between 2 points
    $scope.distance = function (lat1, lon1, lat2, lon2) {
        var distance = Distance.getDistance(lat1, lon1, lat2, lon2);
        return distance;
    }
})



.controller('today_special', function ($scope, $stateParams, Today_special) {
    $scope.my_class = "hide";
    //bind bar_id and selected_day to scope, send it to Today_special service
    $scope.init = function params(bar_id, day_switch) {
        Today_special.get({ 'bar_id': bar_id, 'selected_day': day_switch }).$promise.then(function (response) {
            $scope.Today_special = response;
            //alert($scope.Today_special.special.hide)
            if ($scope.Today_special) {
                $scope.my_class = false;
            }
        })
    }

})



.controller('search', function ($scope, $stateParams, $geolocation, $cordovaLaunchNavigator, Search, Navigate_maps, Distance) {
    $scope.loader = 'show';
    if (typeof analytics !== 'undefined') { analytics.trackView('search/' + $stateParams.day+ '/'+$stateParams.query) }
    $geolocation.getCurrentPosition({
        timeout: 60000
    }).then(function (position) {
        $scope.myPosition = position;
        Search.get({ 'lat': position.coords.latitude, 'lng': position.coords.longitude, 'selected_day': $stateParams.day, 'page': $stateParams.page, 'query': $stateParams.query }).$promise.then(function (response) {
            $scope.loader = "hide";
            $scope.Index = response;
        })

        //refresh the page
        $scope.doRefresh = function () {
            if (typeof analytics !== 'undefined') { analytics.trackView('search/' + $stateParams.day + '/' + $stateParams.query) }
            Search.get({ 'lat': position.coords.latitude, 'lng': position.coords.longitude, 'selected_day': $stateParams.day, 'page': $stateParams.page, 'query': $stateParams.query }).$promise.then(function (response) {
                $scope.Index = response;
            })
         .finally(function () {
             // Stop the ion-refresher from spinning
             $scope.$broadcast('scroll.refreshComplete');
         });
        };

        //set these values for search_form, may or may not be necessary
        $scope.value = $stateParams.query;
        $scope.day = $stateParams.day;

    });

    //map-pin click function
    $scope.navigate = function (lat, lng) {
        dest = lat + ',' + lng
        start = null;
        $cordovaLaunchNavigator.navigate(dest, {
            start: start,
            enableDebug: false
        }).then(function () {
            alert("Navigator launched");
        }, function (err) {
            alert(err);
        });
    }

    //distance between 2 points
    $scope.distance = function (lat1, lon1, lat2, lon2) {
        var distance = Distance.getDistance(lat1, lon1, lat2, lon2);
        return distance;
    }
})



.controller('show', function ($scope, $stateParams, Show, $cordovaLaunchNavigator, Navigate_maps, $localStorage) {
    if (typeof analytics !== 'undefined') { analytics.trackView('show/'+$stateParams.day+'/'+$stateParams.id) }
    Show.get({'selected_day': $stateParams.day, 'id': $stateParams.id}).$promise.then(function(response){
        $scope.Show = response;
    })


    //refresh the page
    $scope.doRefresh = function () {
        if (typeof analytics !== 'undefined') { analytics.trackView('show/' + $stateParams.day + '/' + $stateParams.id) }
        Show.get({ 'selected_day': $stateParams.day, 'id': $stateParams.id }).$promise.then(function (response) {
        $scope.Show = response;
    })
     .finally(function () {
         // Stop the ion-refresher from spinning
         $scope.$broadcast('scroll.refreshComplete');
     });
    };


    //map-pin click function
    $scope.navigate = function(lat,lng) {
        dest = lat + ',' + lng
        start = null;
        $cordovaLaunchNavigator.navigate(dest, {
            start: start,
            enableDebug: false
        }).then(function () {
            alert("Navigator launched");
        }, function (err) {
            alert(err);
        });
    }
    //starred click function -- local storage
    $scope.addRemoveStar = function (id) {
        if (!$localStorage.starred) {
            $localStorage.starred = [];
        }
        starred = $localStorage.starred;
        //alert(starred[0].id)
        var count = 0;
        for (var i = starred.length - 1; i >= 0 ; i--) {
            var item = starred[i];
            if (item.id == id) {
                count = count + 1
                starred.splice(i, 1);
                starred.id = id
                    $localStorage.starred = starred;
            }
        }
        if (count < 1 && id != undefined) {
            var t = { id: id };
            starred.push(t);
            $localStorage.starred = starred;
        }
    }
})


.controller('menu_heading_items', function ($scope, $stateParams, Menu_heading_items) {
    $scope.menu_heading_id = function params(menu_heading_id) {
        Menu_heading_items.get({ 'menu_heading_id': menu_heading_id }).$promise.then(function (response) {
            $scope.Menu_heading_items = response;
        })
    }
})


.controller('starred', function ($scope, $stateParams, $geolocation, $localStorage, Starred, Distance) {
    $scope.starred_none = "hide";
    $scope.starred_not_available = "hide";
    if (typeof analytics !== 'undefined') { analytics.trackView('starred/'+$stateParams.day) }
    $geolocation.getCurrentPosition({
        timeout: 60000
    }).then(function (position) {
        $scope.myPosition = position;
        $scope.lat = $scope.myPosition.coords.latitude
        $scope.lng = $scope.myPosition.coords.longitude
        $scope.day_switch = $stateParams.day
        $scope.list = $localStorage.starred;
        if ($scope.list == null || $scope.list == '') {
            $scope.starred_none = false;
        }
    });
})

.controller('starred_fetch', function ($scope, $stateParams, Starred, $cordovaLaunchNavigator, Navigate_maps, Distance) {
    //$scope.starred_not_available = false;
    $scope.params = function data(bar_id, lat, lng) {
        Starred.get({ 'id': bar_id, 'lat': lat, 'lng': lng, 'selected_day': $stateParams.day }).$promise.then(function (response) {
            $scope.Starred = response;
            if ($scope.Starred.bar.subscribed != false || $scope.Starred.bar.active_card != false && $scope.Starred.bar.one_price != null && $scope.Starred.bar.id != null) {
                $scope.starred_not_available = false;
            }
        })

    //distance between 2 points
        $scope.distance = function (lat1, lon1, lat2, lon2) {
        var distance = Distance.getDistance(lat1, lon1, lat2, lon2);
        return distance;
    }
}


    //map-pin click function
    $scope.navigate = function (lat, lng) {
        dest = lat + ',' + lng
        start = null;
        $cordovaLaunchNavigator.navigate(dest, {
            start: start,
            enableDebug: false
        }).then(function () {
            alert("Navigator launched");
        }, function (err) {
            alert(err);
        });
    }
})



.controller('day', function ($scope, $stateParams, Day) {
    $scope.day = function () {
        //call factory here
        var day = Day.day($stateParams.day)
        return day;
    }
})


.controller('starred_nav', function ($scope, $stateParams, $location) {
    $scope.day_starred = function () {
        d = new Date();
        day_code = d.getDay();
        return day_code
    }
})


.controller('search_form', function ($scope, $stateParams, $state) {

    $scope.submitSearch = function (value) {
        if (value != undefined) {
            $state.go('app.search', { day: new Date().getDay(), page: '1', query: value });
        }
    }

    //make search term stay, but remove it from index
    $scope.$watch(function (scope) { return $stateParams.query },
              function (newValue, oldValue) {
                  $scope.value = newValue;
    });


})


//search_day selector
.controller('search_menu', function ($scope, $stateParams, $location) {
        $scope.get_page = function () {
        page = $stateParams.page;
        return page;
    }
})

//show_menu
.controller('show_menu', function ($scope, $stateParams) {
    $scope.get_id = function () {
        id = $stateParams.id;
        return id;
    }
})


//index_page pagination
.controller('index_page', function ($scope, $stateParams) {
    $scope.get_page = function () {
        page = $stateParams.page;
        return page;
    }

    $scope.get_day = function () {
        day = $stateParams.day;
        return day;
    }
})

//go_home and refresh page
.controller('go_home', function ($scope, $state, $stateParams, $ionicHistory) {
    $scope.home = function () {
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $state.go('app.index', { day: new Date().getDay(), page: '1' }, { reload: true });
    }
})

