﻿angular.module('starter.services', ['ngResource'])


.factory('Index', function ($resource, $location) {
    get_day_code();
    return $resource('https://www.drinkgrab.com/api/v1/query.json?lat=:lat&lng=:lng&day_code=' + day_code + '&selected_day=:selected_day&page=:page');
})

.factory('Today_special', function ($resource) {
    return $resource('https://www.drinkgrab.com/api/v1/fetch_today_special.json?bar_id=:bar_id&selected_day=:selected_day');
})

.factory('Search', function ($resource, $location) {
    if ($location.search().day != null) {
        day_code = $location.search().day
    } else {
        get_day_code();
    }

    return $resource('https://www.drinkgrab.com/api/v1/search.json?lat=:lat&lng=:lng&query=:query&p=search&day=' + day_code + '&selected_day=:selected_day&page=:page');
})

.factory('Show', function ($resource, $location) {
    return $resource('https://www.drinkgrab.com/api/v1/bars/:id.json?day=:selected_day&p=show');
})

.factory('Menu_heading_items', function ($resource, $location) {
    return $resource('https://www.drinkgrab.com/api/v1/menu_heading_items?menu_heading_id=:menu_heading_id')
})

.factory('Starred', function ($resource, $location) {
    if ($location.search().day != null) {
        day_code = $location.search().day
    } else {
        get_day_code();
    }
    return $resource('https://www.drinkgrab.com/api/v1/get_starred.json?id=:id&lat=:lat&lng=:lng&day=' + day_code + '&selected_day=:selected_day');
})


.factory('Day_switch', function ($resource, $location) {
    if ($location.search().selected_day != null) {
        day_switch = $location.search().selected_day
    } else {
        day_switch = get_day_code();
    }
    return day_switch;
})


.factory('Distance', function ($resource, $location) {
    return {
        getDistance: function (lat1, lon1, lat2, lon2) {

            var radlat1 = Math.PI * lat1 / 180
            var radlat2 = Math.PI * lat2 / 180
            var theta = lon1 - lon2
            var radtheta = Math.PI * theta / 180
            var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
            dist = Math.acos(dist)
            dist = dist * 180 / Math.PI
            dist = dist * 60 * 1.1515
            //if (unit == "K") { dist = dist * 1.609344 }
            //if (unit == "N") { dist = dist * 0.8684 }
            dist = Math.round(dist * 10) / 10;
            return dist
        }
    }
})

.factory('Day', function ($resource, $location) {
    //rework this to show today
    return {
        day: function (day_code) {
                if (day_code == 0) {
                    today = 'Sun';
                }
                if (day_code == 1) {
                    today = 'Mon';
                }
                if (day_code == 2) {
                    today = 'Tue';
                }
                if (day_code == 3) {
                    today = 'Wed';
                }
                if (day_code == 4) {
                    today = 'Thu';
                }
                if (day_code == 5) {
                    today = 'Fri';
                }
                if (day_code == 6) {
                    today = 'Sat';
                }
                return today;
        }
    }
})

.factory("Navigate_maps", function ($resource, $location) {
    return {
        navigate: function (lat,lng) {

            var iOSversion, protocol, ver;
            iOSversion = function () {
                var v;
                if (/iP(hone|od|ad)/.test(navigator.platform)) {
                    v = navigator.appVersion.match(/OS (\d+)_(\d+)_?(\d+)?/);
                    return [parseInt(v[1], 10), parseInt(v[2], 10), parseInt(v[3] || 0, 10)];
                }
            };
            if (navigator.platform.indexOf('iPhone') !== -1 || navigator.platform.indexOf('iPod') !== -1) {
                ver = iOSversion() || [0];
                if (ver[0] >= 6) {
                    protocol = 'maps://';
                } else {
                    protocol = 'http://';
                }
                window.location = protocol + 'maps.apple.com/maps?daddr=' + lat + ',' + lng + '&amp;ll=';
            } else {
                window.location('http://maps.google.com?daddr=' + lat + ',' + lng + '&amp;ll=');
            }
        }
    }
})

// Define an Angular service to wrap the plugin
  .factory('$cordovaLaunchNavigator', ['$q', function ($q) {
      "use strict";

      var $cordovaLaunchNavigator = {};
      $cordovaLaunchNavigator.navigate = function (destination, options) {
          var q = $q.defer(),
            isRealDevice = ionic.Platform.isWebView();

          if (!isRealDevice) {
              q.reject("launchnavigator will only work on a real mobile device! It is a NATIVE app launcher.");
          } else {
              try {

                  var successFn = options.successCallBack || function () {
                  },
                    errorFn = options.errorCallback || function () {
                    },
                    _successFn = function () {
                        successFn();
                        q.resolve();
                    },
                    _errorFn = function (err) {
                        errorFn(err);
                        q.reject(err);
                    };

                  options.successCallBack = _successFn;
                  options.errorCallback = _errorFn;

                  launchnavigator.navigate(destination, {
                      app: launchnavigator.APP.APPLE_MAPS
                  });


              } catch (e) {
                  q.reject("Exception: " + e.message);
              }
          }
          return q.promise;
      };
      return $cordovaLaunchNavigator;
  }])